<?php
define('ZENNO_ABSTRACT', 'Zenno_Abstract');

abstract class ZENNO_ABSTRACT
{

    /**
     * Magic __set
     * 
     * @return 
     * @param string $key
     * @param mixed $value
     * @return mixed
     */
    public function __set($key, $value)
    {
        $this->_magicSetAndGet('set', $key, $value);
    }

    /**
     * Magic __get
     * 
     * @return 
     * @param string $key
     * @return mixed
     */
    public function __get($key)
    {
        return $this->_magicSetAndGet('get', $key, null);
    }

    /**
     * TODO: add comment
     * 
     * @return 
     * @param object $type
     * @param object $key
     * @param object $value
     */
    protected function _magicSetAndGet($type, $key, $value)
    {

//        if ($type == 'set' && ! isset($this->_parameters)) {
//            return;
//        }

        $method = "_{$type}" . ucfirst($key);

        if (method_exists($this, $method)) {
            return $this->$method($value);
        }
    }
    
    public function httpRequest($uri, $post = null, $options = null, $timeout = 10)
    {
        $userAgent = 'ZennoConnector';

        $uriComponent = parse_url($uri);
        if ($uriComponent['scheme'] != 'http') {
            throw Exception('Only HTTP request are supported !');
        }

        $fp = fsockopen($uriComponent['host'],
                        isset($uriComponent['port'])
                        ? $uriComponent['port']
                        : 80);
		socket_set_timeout($fp, $timeout);
		
        $requestLines = array();

        $typeRequest = ($post == null) ? 'GET' : 'POST';
        $path = ltrim($uriComponent['path'], '/');
        $requestLines[] = "{$typeRequest} /{$path}{$uriComponent['query']} HTTP/1.1\r\n";
        $requestLines[] = "Host: {$uriComponent['host']}\r\n";
        $requestLines[] = "User-Agent: {$userAgent}\r\n";
        $requestLines[] = "Connection: close\r\n";

        if ($options != null && isset($options['headers'])) {
            foreach ($options['headers'] as $name => $value) {
                $requestLines[] = "{$name}: {$value}\r\n";
            }
        } else {
            $requestLines[] = "Content-Type: application/x-www-form-urlencoded\r\n";
        }

        if ($post != null) {
            // POST request
            $data = array();
            if (is_array($post)) {
                foreach ($post as $k => $v) {
                    $data[] = "$k=$v";
                }
                $postString = implode('&', $data);
            } else {
                $postString = $post;
            }
            // send the request headers:

            $requestLines[] = "Content-Length: " . strlen($postString) . "\r\n\r\n";
            $requestLines[] = $postString;
        } else {
            // GET request
            $requestLines[count($requestLines) - 1] .= "\r\n";
        }
		var_dump($requestLines);
        foreach ($requestLines as $line) {
            fputs($fp, $line);
        }
        $result = ''; 
        while(!feof($fp)) {
            // receive the results of the request
			$t = fgets($fp, 128);
			echo $t;
            $result .= $t;
        }

        // close the socket connection:
        fclose($fp);

        $result = explode("\r\n\r\n", $result, 2);

        $header = isset($result[0]) ? $result[0] : '';
        $body = isset($result[1]) ? $result[1] : '';
        return (object)array('header' => $header,
                             'body'   => $body);
    }
}
