<?php
if (! defined('ZENNO_ABSTRACT')) {
    throw new Exception('Connection error in ' . __FILE__);
}

class CommandTransfer extends ZENNO_ABSTRACT
{
    protected $_fullAddress;

    /**
     * TODO: add comment
     * 
     * @var bool
     */
    protected $_errorDetected;

    /**
     * TODO: add comment
     * 
     * @var string
     */
    protected $_resultGetingMessage;


    protected function _getErrorDetected()
    {
        return $this->_errorDetected;
    }

    /**
     * 
     * @return CommandTransfer
     * @param object $server
     * @param object $port
     * @param object $additionalPath
     */
    public function __construct($server, $port, $additionalPath)
    {
        $additionalPath = ltrim($additionalPath, '/');
        $this->_fullAddress = "http://{$server}:{$port}/{$additionalPath}";
        $this->_resultGetingMessage = self::CreateMessage('server', 'GetResult', '', '');
    }

    /**
     * TODO: add comment
     * 
     * @return string 
     * @param string $address
     * @param string $commandName
     * @param array $simplParameters
     * @param array $vectorParameter
     */
    public static function CreateMessage($address, $commandName, $simpleParameters, $vectorParameter = null)
    {
        $string = array($address, $commandName, 'true');
        
        if (is_array($simpleParameters) && is_array($vectorParameter)) {
            if ($simpleParameters != null || $vectorParameter != null) {
                $string[] = 'true';
                $doc = new DOMDocument();
                // создаем корневую ноду она всегада одна единственная
                $root = $doc->createElement('XMLC');
                $doc->appendChild($root);
    
                // добавляем параметры
                if ($simpleParameters != null) {
                    for ($i = 0; $i < count($simpleParameters); $i+=2) {
                        $key   = $simpleParameters[$i];
                        $value = $simpleParameters[$i + 1];
                        $node  = $node = $doc->createElement($key, $value);
                        $root->appendChild($node);
                    }
                }
    
                if ($vectorParameter != null) {
                    //добавляем массив строк
                    $arrNode = $doc->createElement('Array');
                    foreach ($vectorParameter as $item) {
                        $node = $doc->createElement('Item', $item);
						$arrNode->appendChild($node);
                    }
                    $root->appendChild($arrNode);
                }
                $string[] = $doc->saveXml();
            } else {
                $string[] = 'false';
                $string[] = '';
            }

            //return sb.ToString();
        } else if (is_array($simpleParameters) && $vectorParameter == null) {
            $string[] = 'false';
            $string[] = implode("\r\n", $simpleParameters);

        } else if (is_string($simpleParameters) && is_string($vectorParameter)){
            $string[] = 'false';
            $string[] = $simpleParameters;
            $string[] = $vectorParameter;
        }

        return implode("\r\n", $string);
    }


    public function SendMessageWait($message, $timeout = 10)
    {
        $this->_errorDetected = false;
        try
        {
            $response = $this->httpRequest($this->_fullAddress, $message, null, $timeout);

            $qq = explode("\r\n", $response->body, 3);
            if (count($qq) == 3 && strtolower($qq[0]) == 'false') {
                return $qq[2];
            }
        } catch (Exception $e){
            die($e);
        }
        $this->_errorDetected = true;
        return '';
    }
}
